import { ExceptionOptionType as __ExceptionOptionType } from "@smithy/smithy-client";
import { ElastiCacheServiceException as __BaseException } from "./ElastiCacheServiceException";
export interface Tag {
  Key?: string | undefined;
  Value?: string | undefined;
}
export interface AddTagsToResourceMessage {
  ResourceName: string | undefined;
  Tags: Tag[] | undefined;
}
export declare class CacheClusterNotFoundFault extends __BaseException {
  readonly name: "CacheClusterNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<CacheClusterNotFoundFault, __BaseException>
  );
}
export declare class CacheParameterGroupNotFoundFault extends __BaseException {
  readonly name: "CacheParameterGroupNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CacheParameterGroupNotFoundFault,
      __BaseException
    >
  );
}
export declare class CacheSecurityGroupNotFoundFault extends __BaseException {
  readonly name: "CacheSecurityGroupNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CacheSecurityGroupNotFoundFault,
      __BaseException
    >
  );
}
export declare class CacheSubnetGroupNotFoundFault extends __BaseException {
  readonly name: "CacheSubnetGroupNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<CacheSubnetGroupNotFoundFault, __BaseException>
  );
}
export declare class InvalidARNFault extends __BaseException {
  readonly name: "InvalidARNFault";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<InvalidARNFault, __BaseException>);
}
export declare class InvalidReplicationGroupStateFault extends __BaseException {
  readonly name: "InvalidReplicationGroupStateFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      InvalidReplicationGroupStateFault,
      __BaseException
    >
  );
}
export declare class InvalidServerlessCacheSnapshotStateFault extends __BaseException {
  readonly name: "InvalidServerlessCacheSnapshotStateFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      InvalidServerlessCacheSnapshotStateFault,
      __BaseException
    >
  );
}
export declare class InvalidServerlessCacheStateFault extends __BaseException {
  readonly name: "InvalidServerlessCacheStateFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      InvalidServerlessCacheStateFault,
      __BaseException
    >
  );
}
export declare class ReplicationGroupNotFoundFault extends __BaseException {
  readonly name: "ReplicationGroupNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<ReplicationGroupNotFoundFault, __BaseException>
  );
}
export declare class ReservedCacheNodeNotFoundFault extends __BaseException {
  readonly name: "ReservedCacheNodeNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<ReservedCacheNodeNotFoundFault, __BaseException>
  );
}
export declare class ServerlessCacheNotFoundFault extends __BaseException {
  readonly name: "ServerlessCacheNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<ServerlessCacheNotFoundFault, __BaseException>
  );
}
export declare class ServerlessCacheSnapshotNotFoundFault extends __BaseException {
  readonly name: "ServerlessCacheSnapshotNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      ServerlessCacheSnapshotNotFoundFault,
      __BaseException
    >
  );
}
export declare class SnapshotNotFoundFault extends __BaseException {
  readonly name: "SnapshotNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<SnapshotNotFoundFault, __BaseException>
  );
}
export interface TagListMessage {
  TagList?: Tag[] | undefined;
}
export declare class TagQuotaPerResourceExceeded extends __BaseException {
  readonly name: "TagQuotaPerResourceExceeded";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<TagQuotaPerResourceExceeded, __BaseException>
  );
}
export declare class UserGroupNotFoundFault extends __BaseException {
  readonly name: "UserGroupNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<UserGroupNotFoundFault, __BaseException>
  );
}
export declare class UserNotFoundFault extends __BaseException {
  readonly name: "UserNotFoundFault";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<UserNotFoundFault, __BaseException>);
}
export interface AllowedNodeTypeModificationsMessage {
  ScaleUpModifications?: string[] | undefined;
  ScaleDownModifications?: string[] | undefined;
}
export declare class AuthorizationAlreadyExistsFault extends __BaseException {
  readonly name: "AuthorizationAlreadyExistsFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      AuthorizationAlreadyExistsFault,
      __BaseException
    >
  );
}
export interface AuthorizeCacheSecurityGroupIngressMessage {
  CacheSecurityGroupName: string | undefined;
  EC2SecurityGroupName: string | undefined;
  EC2SecurityGroupOwnerId: string | undefined;
}
export interface EC2SecurityGroup {
  Status?: string | undefined;
  EC2SecurityGroupName?: string | undefined;
  EC2SecurityGroupOwnerId?: string | undefined;
}
export interface CacheSecurityGroup {
  OwnerId?: string | undefined;
  CacheSecurityGroupName?: string | undefined;
  Description?: string | undefined;
  EC2SecurityGroups?: EC2SecurityGroup[] | undefined;
  ARN?: string | undefined;
}
export interface AuthorizeCacheSecurityGroupIngressResult {
  CacheSecurityGroup?: CacheSecurityGroup | undefined;
}
export declare class InvalidCacheSecurityGroupStateFault extends __BaseException {
  readonly name: "InvalidCacheSecurityGroupStateFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      InvalidCacheSecurityGroupStateFault,
      __BaseException
    >
  );
}
export declare class InvalidParameterCombinationException extends __BaseException {
  readonly name: "InvalidParameterCombinationException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      InvalidParameterCombinationException,
      __BaseException
    >
  );
}
export declare class InvalidParameterValueException extends __BaseException {
  readonly name: "InvalidParameterValueException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidParameterValueException, __BaseException>
  );
}
export interface BatchApplyUpdateActionMessage {
  ReplicationGroupIds?: string[] | undefined;
  CacheClusterIds?: string[] | undefined;
  ServiceUpdateName: string | undefined;
}
export declare class ServiceUpdateNotFoundFault extends __BaseException {
  readonly name: "ServiceUpdateNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<ServiceUpdateNotFoundFault, __BaseException>
  );
}
export declare const UpdateActionStatus: {
  readonly COMPLETE: "complete";
  readonly IN_PROGRESS: "in-progress";
  readonly NOT_APPLICABLE: "not-applicable";
  readonly NOT_APPLIED: "not-applied";
  readonly SCHEDULED: "scheduled";
  readonly SCHEDULING: "scheduling";
  readonly STOPPED: "stopped";
  readonly STOPPING: "stopping";
  readonly WAITING_TO_START: "waiting-to-start";
};
export type UpdateActionStatus =
  (typeof UpdateActionStatus)[keyof typeof UpdateActionStatus];
export interface ProcessedUpdateAction {
  ReplicationGroupId?: string | undefined;
  CacheClusterId?: string | undefined;
  ServiceUpdateName?: string | undefined;
  UpdateActionStatus?: UpdateActionStatus | undefined;
}
export interface UnprocessedUpdateAction {
  ReplicationGroupId?: string | undefined;
  CacheClusterId?: string | undefined;
  ServiceUpdateName?: string | undefined;
  ErrorType?: string | undefined;
  ErrorMessage?: string | undefined;
}
export interface UpdateActionResultsMessage {
  ProcessedUpdateActions?: ProcessedUpdateAction[] | undefined;
  UnprocessedUpdateActions?: UnprocessedUpdateAction[] | undefined;
}
export interface BatchStopUpdateActionMessage {
  ReplicationGroupIds?: string[] | undefined;
  CacheClusterIds?: string[] | undefined;
  ServiceUpdateName: string | undefined;
}
export interface CompleteMigrationMessage {
  ReplicationGroupId: string | undefined;
  Force?: boolean | undefined;
}
export declare const AutomaticFailoverStatus: {
  readonly DISABLED: "disabled";
  readonly DISABLING: "disabling";
  readonly ENABLED: "enabled";
  readonly ENABLING: "enabling";
};
export type AutomaticFailoverStatus =
  (typeof AutomaticFailoverStatus)[keyof typeof AutomaticFailoverStatus];
export declare const ClusterMode: {
  readonly COMPATIBLE: "compatible";
  readonly DISABLED: "disabled";
  readonly ENABLED: "enabled";
};
export type ClusterMode = (typeof ClusterMode)[keyof typeof ClusterMode];
export interface Endpoint {
  Address?: string | undefined;
  Port?: number | undefined;
}
export declare const DataTieringStatus: {
  readonly DISABLED: "disabled";
  readonly ENABLED: "enabled";
};
export type DataTieringStatus =
  (typeof DataTieringStatus)[keyof typeof DataTieringStatus];
export interface GlobalReplicationGroupInfo {
  GlobalReplicationGroupId?: string | undefined;
  GlobalReplicationGroupMemberRole?: string | undefined;
}
export declare const IpDiscovery: {
  readonly IPV4: "ipv4";
  readonly IPV6: "ipv6";
};
export type IpDiscovery = (typeof IpDiscovery)[keyof typeof IpDiscovery];
export interface CloudWatchLogsDestinationDetails {
  LogGroup?: string | undefined;
}
export interface KinesisFirehoseDestinationDetails {
  DeliveryStream?: string | undefined;
}
export interface DestinationDetails {
  CloudWatchLogsDetails?: CloudWatchLogsDestinationDetails | undefined;
  KinesisFirehoseDetails?: KinesisFirehoseDestinationDetails | undefined;
}
export declare const DestinationType: {
  readonly CloudWatchLogs: "cloudwatch-logs";
  readonly KinesisFirehose: "kinesis-firehose";
};
export type DestinationType =
  (typeof DestinationType)[keyof typeof DestinationType];
export declare const LogFormat: {
  readonly JSON: "json";
  readonly TEXT: "text";
};
export type LogFormat = (typeof LogFormat)[keyof typeof LogFormat];
export declare const LogType: {
  readonly ENGINE_LOG: "engine-log";
  readonly SLOW_LOG: "slow-log";
};
export type LogType = (typeof LogType)[keyof typeof LogType];
export declare const LogDeliveryConfigurationStatus: {
  readonly ACTIVE: "active";
  readonly DISABLING: "disabling";
  readonly ENABLING: "enabling";
  readonly ERROR: "error";
  readonly MODIFYING: "modifying";
};
export type LogDeliveryConfigurationStatus =
  (typeof LogDeliveryConfigurationStatus)[keyof typeof LogDeliveryConfigurationStatus];
export interface LogDeliveryConfiguration {
  LogType?: LogType | undefined;
  DestinationType?: DestinationType | undefined;
  DestinationDetails?: DestinationDetails | undefined;
  LogFormat?: LogFormat | undefined;
  Status?: LogDeliveryConfigurationStatus | undefined;
  Message?: string | undefined;
}
export declare const MultiAZStatus: {
  readonly DISABLED: "disabled";
  readonly ENABLED: "enabled";
};
export type MultiAZStatus = (typeof MultiAZStatus)[keyof typeof MultiAZStatus];
export declare const NetworkType: {
  readonly DUAL_STACK: "dual_stack";
  readonly IPV4: "ipv4";
  readonly IPV6: "ipv6";
};
export type NetworkType = (typeof NetworkType)[keyof typeof NetworkType];
export interface NodeGroupMember {
  CacheClusterId?: string | undefined;
  CacheNodeId?: string | undefined;
  ReadEndpoint?: Endpoint | undefined;
  PreferredAvailabilityZone?: string | undefined;
  PreferredOutpostArn?: string | undefined;
  CurrentRole?: string | undefined;
}
export interface NodeGroup {
  NodeGroupId?: string | undefined;
  Status?: string | undefined;
  PrimaryEndpoint?: Endpoint | undefined;
  ReaderEndpoint?: Endpoint | undefined;
  Slots?: string | undefined;
  NodeGroupMembers?: NodeGroupMember[] | undefined;
}
export declare const AuthTokenUpdateStatus: {
  readonly ROTATING: "ROTATING";
  readonly SETTING: "SETTING";
};
export type AuthTokenUpdateStatus =
  (typeof AuthTokenUpdateStatus)[keyof typeof AuthTokenUpdateStatus];
export declare const PendingAutomaticFailoverStatus: {
  readonly DISABLED: "disabled";
  readonly ENABLED: "enabled";
};
export type PendingAutomaticFailoverStatus =
  (typeof PendingAutomaticFailoverStatus)[keyof typeof PendingAutomaticFailoverStatus];
export interface PendingLogDeliveryConfiguration {
  LogType?: LogType | undefined;
  DestinationType?: DestinationType | undefined;
  DestinationDetails?: DestinationDetails | undefined;
  LogFormat?: LogFormat | undefined;
}
export interface SlotMigration {
  ProgressPercentage?: number | undefined;
}
export interface ReshardingStatus {
  SlotMigration?: SlotMigration | undefined;
}
export declare const TransitEncryptionMode: {
  readonly PREFERRED: "preferred";
  readonly REQUIRED: "required";
};
export type TransitEncryptionMode =
  (typeof TransitEncryptionMode)[keyof typeof TransitEncryptionMode];
export interface UserGroupsUpdateStatus {
  UserGroupIdsToAdd?: string[] | undefined;
  UserGroupIdsToRemove?: string[] | undefined;
}
export interface ReplicationGroupPendingModifiedValues {
  PrimaryClusterId?: string | undefined;
  AutomaticFailoverStatus?: PendingAutomaticFailoverStatus | undefined;
  Resharding?: ReshardingStatus | undefined;
  AuthTokenStatus?: AuthTokenUpdateStatus | undefined;
  UserGroups?: UserGroupsUpdateStatus | undefined;
  LogDeliveryConfigurations?: PendingLogDeliveryConfiguration[] | undefined;
  TransitEncryptionEnabled?: boolean | undefined;
  TransitEncryptionMode?: TransitEncryptionMode | undefined;
  ClusterMode?: ClusterMode | undefined;
}
export interface ReplicationGroup {
  ReplicationGroupId?: string | undefined;
  Description?: string | undefined;
  GlobalReplicationGroupInfo?: GlobalReplicationGroupInfo | undefined;
  Status?: string | undefined;
  PendingModifiedValues?: ReplicationGroupPendingModifiedValues | undefined;
  MemberClusters?: string[] | undefined;
  NodeGroups?: NodeGroup[] | undefined;
  SnapshottingClusterId?: string | undefined;
  AutomaticFailover?: AutomaticFailoverStatus | undefined;
  MultiAZ?: MultiAZStatus | undefined;
  ConfigurationEndpoint?: Endpoint | undefined;
  SnapshotRetentionLimit?: number | undefined;
  SnapshotWindow?: string | undefined;
  ClusterEnabled?: boolean | undefined;
  CacheNodeType?: string | undefined;
  AuthTokenEnabled?: boolean | undefined;
  AuthTokenLastModifiedDate?: Date | undefined;
  TransitEncryptionEnabled?: boolean | undefined;
  AtRestEncryptionEnabled?: boolean | undefined;
  MemberClustersOutpostArns?: string[] | undefined;
  KmsKeyId?: string | undefined;
  ARN?: string | undefined;
  UserGroupIds?: string[] | undefined;
  LogDeliveryConfigurations?: LogDeliveryConfiguration[] | undefined;
  ReplicationGroupCreateTime?: Date | undefined;
  DataTiering?: DataTieringStatus | undefined;
  AutoMinorVersionUpgrade?: boolean | undefined;
  NetworkType?: NetworkType | undefined;
  IpDiscovery?: IpDiscovery | undefined;
  TransitEncryptionMode?: TransitEncryptionMode | undefined;
  ClusterMode?: ClusterMode | undefined;
  Engine?: string | undefined;
}
export interface CompleteMigrationResponse {
  ReplicationGroup?: ReplicationGroup | undefined;
}
export declare class ReplicationGroupNotUnderMigrationFault extends __BaseException {
  readonly name: "ReplicationGroupNotUnderMigrationFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      ReplicationGroupNotUnderMigrationFault,
      __BaseException
    >
  );
}
export interface CopyServerlessCacheSnapshotRequest {
  SourceServerlessCacheSnapshotName: string | undefined;
  TargetServerlessCacheSnapshotName: string | undefined;
  KmsKeyId?: string | undefined;
  Tags?: Tag[] | undefined;
}
export interface ServerlessCacheConfiguration {
  ServerlessCacheName?: string | undefined;
  Engine?: string | undefined;
  MajorEngineVersion?: string | undefined;
}
export interface ServerlessCacheSnapshot {
  ServerlessCacheSnapshotName?: string | undefined;
  ARN?: string | undefined;
  KmsKeyId?: string | undefined;
  SnapshotType?: string | undefined;
  Status?: string | undefined;
  CreateTime?: Date | undefined;
  ExpiryTime?: Date | undefined;
  BytesUsedForCache?: string | undefined;
  ServerlessCacheConfiguration?: ServerlessCacheConfiguration | undefined;
}
export interface CopyServerlessCacheSnapshotResponse {
  ServerlessCacheSnapshot?: ServerlessCacheSnapshot | undefined;
}
export declare class ServerlessCacheSnapshotAlreadyExistsFault extends __BaseException {
  readonly name: "ServerlessCacheSnapshotAlreadyExistsFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      ServerlessCacheSnapshotAlreadyExistsFault,
      __BaseException
    >
  );
}
export declare class ServerlessCacheSnapshotQuotaExceededFault extends __BaseException {
  readonly name: "ServerlessCacheSnapshotQuotaExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      ServerlessCacheSnapshotQuotaExceededFault,
      __BaseException
    >
  );
}
export declare class ServiceLinkedRoleNotFoundFault extends __BaseException {
  readonly name: "ServiceLinkedRoleNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<ServiceLinkedRoleNotFoundFault, __BaseException>
  );
}
export interface CopySnapshotMessage {
  SourceSnapshotName: string | undefined;
  TargetSnapshotName: string | undefined;
  TargetBucket?: string | undefined;
  KmsKeyId?: string | undefined;
  Tags?: Tag[] | undefined;
}
export interface NodeGroupConfiguration {
  NodeGroupId?: string | undefined;
  Slots?: string | undefined;
  ReplicaCount?: number | undefined;
  PrimaryAvailabilityZone?: string | undefined;
  ReplicaAvailabilityZones?: string[] | undefined;
  PrimaryOutpostArn?: string | undefined;
  ReplicaOutpostArns?: string[] | undefined;
}
export interface NodeSnapshot {
  CacheClusterId?: string | undefined;
  NodeGroupId?: string | undefined;
  CacheNodeId?: string | undefined;
  NodeGroupConfiguration?: NodeGroupConfiguration | undefined;
  CacheSize?: string | undefined;
  CacheNodeCreateTime?: Date | undefined;
  SnapshotCreateTime?: Date | undefined;
}
export interface Snapshot {
  SnapshotName?: string | undefined;
  ReplicationGroupId?: string | undefined;
  ReplicationGroupDescription?: string | undefined;
  CacheClusterId?: string | undefined;
  SnapshotStatus?: string | undefined;
  SnapshotSource?: string | undefined;
  CacheNodeType?: string | undefined;
  Engine?: string | undefined;
  EngineVersion?: string | undefined;
  NumCacheNodes?: number | undefined;
  PreferredAvailabilityZone?: string | undefined;
  PreferredOutpostArn?: string | undefined;
  CacheClusterCreateTime?: Date | undefined;
  PreferredMaintenanceWindow?: string | undefined;
  TopicArn?: string | undefined;
  Port?: number | undefined;
  CacheParameterGroupName?: string | undefined;
  CacheSubnetGroupName?: string | undefined;
  VpcId?: string | undefined;
  AutoMinorVersionUpgrade?: boolean | undefined;
  SnapshotRetentionLimit?: number | undefined;
  SnapshotWindow?: string | undefined;
  NumNodeGroups?: number | undefined;
  AutomaticFailover?: AutomaticFailoverStatus | undefined;
  NodeSnapshots?: NodeSnapshot[] | undefined;
  KmsKeyId?: string | undefined;
  ARN?: string | undefined;
  DataTiering?: DataTieringStatus | undefined;
}
export interface CopySnapshotResult {
  Snapshot?: Snapshot | undefined;
}
export declare class InvalidSnapshotStateFault extends __BaseException {
  readonly name: "InvalidSnapshotStateFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidSnapshotStateFault, __BaseException>
  );
}
export declare class SnapshotAlreadyExistsFault extends __BaseException {
  readonly name: "SnapshotAlreadyExistsFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<SnapshotAlreadyExistsFault, __BaseException>
  );
}
export declare class SnapshotQuotaExceededFault extends __BaseException {
  readonly name: "SnapshotQuotaExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<SnapshotQuotaExceededFault, __BaseException>
  );
}
export declare class CacheClusterAlreadyExistsFault extends __BaseException {
  readonly name: "CacheClusterAlreadyExistsFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<CacheClusterAlreadyExistsFault, __BaseException>
  );
}
export declare class ClusterQuotaForCustomerExceededFault extends __BaseException {
  readonly name: "ClusterQuotaForCustomerExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      ClusterQuotaForCustomerExceededFault,
      __BaseException
    >
  );
}
export declare const AZMode: {
  readonly CROSS_AZ: "cross-az";
  readonly SINGLE_AZ: "single-az";
};
export type AZMode = (typeof AZMode)[keyof typeof AZMode];
export interface LogDeliveryConfigurationRequest {
  LogType?: LogType | undefined;
  DestinationType?: DestinationType | undefined;
  DestinationDetails?: DestinationDetails | undefined;
  LogFormat?: LogFormat | undefined;
  Enabled?: boolean | undefined;
}
export declare const OutpostMode: {
  readonly CROSS_OUTPOST: "cross-outpost";
  readonly SINGLE_OUTPOST: "single-outpost";
};
export type OutpostMode = (typeof OutpostMode)[keyof typeof OutpostMode];
export interface CreateCacheClusterMessage {
  CacheClusterId: string | undefined;
  ReplicationGroupId?: string | undefined;
  AZMode?: AZMode | undefined;
  PreferredAvailabilityZone?: string | undefined;
  PreferredAvailabilityZones?: string[] | undefined;
  NumCacheNodes?: number | undefined;
  CacheNodeType?: string | undefined;
  Engine?: string | undefined;
  EngineVersion?: string | undefined;
  CacheParameterGroupName?: string | undefined;
  CacheSubnetGroupName?: string | undefined;
  CacheSecurityGroupNames?: string[] | undefined;
  SecurityGroupIds?: string[] | undefined;
  Tags?: Tag[] | undefined;
  SnapshotArns?: string[] | undefined;
  SnapshotName?: string | undefined;
  PreferredMaintenanceWindow?: string | undefined;
  Port?: number | undefined;
  NotificationTopicArn?: string | undefined;
  AutoMinorVersionUpgrade?: boolean | undefined;
  SnapshotRetentionLimit?: number | undefined;
  SnapshotWindow?: string | undefined;
  AuthToken?: string | undefined;
  OutpostMode?: OutpostMode | undefined;
  PreferredOutpostArn?: string | undefined;
  PreferredOutpostArns?: string[] | undefined;
  LogDeliveryConfigurations?: LogDeliveryConfigurationRequest[] | undefined;
  TransitEncryptionEnabled?: boolean | undefined;
  NetworkType?: NetworkType | undefined;
  IpDiscovery?: IpDiscovery | undefined;
}
export interface CacheNode {
  CacheNodeId?: string | undefined;
  CacheNodeStatus?: string | undefined;
  CacheNodeCreateTime?: Date | undefined;
  Endpoint?: Endpoint | undefined;
  ParameterGroupStatus?: string | undefined;
  SourceCacheNodeId?: string | undefined;
  CustomerAvailabilityZone?: string | undefined;
  CustomerOutpostArn?: string | undefined;
}
export interface CacheParameterGroupStatus {
  CacheParameterGroupName?: string | undefined;
  ParameterApplyStatus?: string | undefined;
  CacheNodeIdsToReboot?: string[] | undefined;
}
export interface CacheSecurityGroupMembership {
  CacheSecurityGroupName?: string | undefined;
  Status?: string | undefined;
}
export interface NotificationConfiguration {
  TopicArn?: string | undefined;
  TopicStatus?: string | undefined;
}
export interface ScaleConfig {
  ScalePercentage?: number | undefined;
  ScaleIntervalMinutes?: number | undefined;
}
export interface PendingModifiedValues {
  NumCacheNodes?: number | undefined;
  CacheNodeIdsToRemove?: string[] | undefined;
  EngineVersion?: string | undefined;
  CacheNodeType?: string | undefined;
  AuthTokenStatus?: AuthTokenUpdateStatus | undefined;
  LogDeliveryConfigurations?: PendingLogDeliveryConfiguration[] | undefined;
  TransitEncryptionEnabled?: boolean | undefined;
  TransitEncryptionMode?: TransitEncryptionMode | undefined;
  ScaleConfig?: ScaleConfig | undefined;
}
export interface SecurityGroupMembership {
  SecurityGroupId?: string | undefined;
  Status?: string | undefined;
}
export interface CacheCluster {
  CacheClusterId?: string | undefined;
  ConfigurationEndpoint?: Endpoint | undefined;
  ClientDownloadLandingPage?: string | undefined;
  CacheNodeType?: string | undefined;
  Engine?: string | undefined;
  EngineVersion?: string | undefined;
  CacheClusterStatus?: string | undefined;
  NumCacheNodes?: number | undefined;
  PreferredAvailabilityZone?: string | undefined;
  PreferredOutpostArn?: string | undefined;
  CacheClusterCreateTime?: Date | undefined;
  PreferredMaintenanceWindow?: string | undefined;
  PendingModifiedValues?: PendingModifiedValues | undefined;
  NotificationConfiguration?: NotificationConfiguration | undefined;
  CacheSecurityGroups?: CacheSecurityGroupMembership[] | undefined;
  CacheParameterGroup?: CacheParameterGroupStatus | undefined;
  CacheSubnetGroupName?: string | undefined;
  CacheNodes?: CacheNode[] | undefined;
  AutoMinorVersionUpgrade?: boolean | undefined;
  SecurityGroups?: SecurityGroupMembership[] | undefined;
  ReplicationGroupId?: string | undefined;
  SnapshotRetentionLimit?: number | undefined;
  SnapshotWindow?: string | undefined;
  AuthTokenEnabled?: boolean | undefined;
  AuthTokenLastModifiedDate?: Date | undefined;
  TransitEncryptionEnabled?: boolean | undefined;
  AtRestEncryptionEnabled?: boolean | undefined;
  ARN?: string | undefined;
  ReplicationGroupLogDeliveryEnabled?: boolean | undefined;
  LogDeliveryConfigurations?: LogDeliveryConfiguration[] | undefined;
  NetworkType?: NetworkType | undefined;
  IpDiscovery?: IpDiscovery | undefined;
  TransitEncryptionMode?: TransitEncryptionMode | undefined;
}
export interface CreateCacheClusterResult {
  CacheCluster?: CacheCluster | undefined;
}
export declare class InsufficientCacheClusterCapacityFault extends __BaseException {
  readonly name: "InsufficientCacheClusterCapacityFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      InsufficientCacheClusterCapacityFault,
      __BaseException
    >
  );
}
export declare class InvalidVPCNetworkStateFault extends __BaseException {
  readonly name: "InvalidVPCNetworkStateFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidVPCNetworkStateFault, __BaseException>
  );
}
export declare class NodeQuotaForClusterExceededFault extends __BaseException {
  readonly name: "NodeQuotaForClusterExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      NodeQuotaForClusterExceededFault,
      __BaseException
    >
  );
}
export declare class NodeQuotaForCustomerExceededFault extends __BaseException {
  readonly name: "NodeQuotaForCustomerExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      NodeQuotaForCustomerExceededFault,
      __BaseException
    >
  );
}
export declare class CacheParameterGroupAlreadyExistsFault extends __BaseException {
  readonly name: "CacheParameterGroupAlreadyExistsFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CacheParameterGroupAlreadyExistsFault,
      __BaseException
    >
  );
}
export declare class CacheParameterGroupQuotaExceededFault extends __BaseException {
  readonly name: "CacheParameterGroupQuotaExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CacheParameterGroupQuotaExceededFault,
      __BaseException
    >
  );
}
export interface CreateCacheParameterGroupMessage {
  CacheParameterGroupName: string | undefined;
  CacheParameterGroupFamily: string | undefined;
  Description: string | undefined;
  Tags?: Tag[] | undefined;
}
export interface CacheParameterGroup {
  CacheParameterGroupName?: string | undefined;
  CacheParameterGroupFamily?: string | undefined;
  Description?: string | undefined;
  IsGlobal?: boolean | undefined;
  ARN?: string | undefined;
}
export interface CreateCacheParameterGroupResult {
  CacheParameterGroup?: CacheParameterGroup | undefined;
}
export declare class InvalidCacheParameterGroupStateFault extends __BaseException {
  readonly name: "InvalidCacheParameterGroupStateFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      InvalidCacheParameterGroupStateFault,
      __BaseException
    >
  );
}
export declare class CacheSecurityGroupAlreadyExistsFault extends __BaseException {
  readonly name: "CacheSecurityGroupAlreadyExistsFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CacheSecurityGroupAlreadyExistsFault,
      __BaseException
    >
  );
}
export declare class CacheSecurityGroupQuotaExceededFault extends __BaseException {
  readonly name: "CacheSecurityGroupQuotaExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CacheSecurityGroupQuotaExceededFault,
      __BaseException
    >
  );
}
export interface CreateCacheSecurityGroupMessage {
  CacheSecurityGroupName: string | undefined;
  Description: string | undefined;
  Tags?: Tag[] | undefined;
}
export interface CreateCacheSecurityGroupResult {
  CacheSecurityGroup?: CacheSecurityGroup | undefined;
}
export declare class CacheSubnetGroupAlreadyExistsFault extends __BaseException {
  readonly name: "CacheSubnetGroupAlreadyExistsFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CacheSubnetGroupAlreadyExistsFault,
      __BaseException
    >
  );
}
export declare class CacheSubnetGroupQuotaExceededFault extends __BaseException {
  readonly name: "CacheSubnetGroupQuotaExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CacheSubnetGroupQuotaExceededFault,
      __BaseException
    >
  );
}
export declare class CacheSubnetQuotaExceededFault extends __BaseException {
  readonly name: "CacheSubnetQuotaExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<CacheSubnetQuotaExceededFault, __BaseException>
  );
}
export interface CreateCacheSubnetGroupMessage {
  CacheSubnetGroupName: string | undefined;
  CacheSubnetGroupDescription: string | undefined;
  SubnetIds: string[] | undefined;
  Tags?: Tag[] | undefined;
}
export interface AvailabilityZone {
  Name?: string | undefined;
}
export interface SubnetOutpost {
  SubnetOutpostArn?: string | undefined;
}
export interface Subnet {
  SubnetIdentifier?: string | undefined;
  SubnetAvailabilityZone?: AvailabilityZone | undefined;
  SubnetOutpost?: SubnetOutpost | undefined;
  SupportedNetworkTypes?: NetworkType[] | undefined;
}
export interface CacheSubnetGroup {
  CacheSubnetGroupName?: string | undefined;
  CacheSubnetGroupDescription?: string | undefined;
  VpcId?: string | undefined;
  Subnets?: Subnet[] | undefined;
  ARN?: string | undefined;
  SupportedNetworkTypes?: NetworkType[] | undefined;
}
export interface CreateCacheSubnetGroupResult {
  CacheSubnetGroup?: CacheSubnetGroup | undefined;
}
export declare class InvalidSubnet extends __BaseException {
  readonly name: "InvalidSubnet";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<InvalidSubnet, __BaseException>);
}
export declare class SubnetNotAllowedFault extends __BaseException {
  readonly name: "SubnetNotAllowedFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<SubnetNotAllowedFault, __BaseException>
  );
}
export interface CreateGlobalReplicationGroupMessage {
  GlobalReplicationGroupIdSuffix: string | undefined;
  GlobalReplicationGroupDescription?: string | undefined;
  PrimaryReplicationGroupId: string | undefined;
}
export interface GlobalNodeGroup {
  GlobalNodeGroupId?: string | undefined;
  Slots?: string | undefined;
}
export interface GlobalReplicationGroupMember {
  ReplicationGroupId?: string | undefined;
  ReplicationGroupRegion?: string | undefined;
  Role?: string | undefined;
  AutomaticFailover?: AutomaticFailoverStatus | undefined;
  Status?: string | undefined;
}
export interface GlobalReplicationGroup {
  GlobalReplicationGroupId?: string | undefined;
  GlobalReplicationGroupDescription?: string | undefined;
  Status?: string | undefined;
  CacheNodeType?: string | undefined;
  Engine?: string | undefined;
  EngineVersion?: string | undefined;
  Members?: GlobalReplicationGroupMember[] | undefined;
  ClusterEnabled?: boolean | undefined;
  GlobalNodeGroups?: GlobalNodeGroup[] | undefined;
  AuthTokenEnabled?: boolean | undefined;
  TransitEncryptionEnabled?: boolean | undefined;
  AtRestEncryptionEnabled?: boolean | undefined;
  ARN?: string | undefined;
}
export interface CreateGlobalReplicationGroupResult {
  GlobalReplicationGroup?: GlobalReplicationGroup | undefined;
}
export declare class GlobalReplicationGroupAlreadyExistsFault extends __BaseException {
  readonly name: "GlobalReplicationGroupAlreadyExistsFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      GlobalReplicationGroupAlreadyExistsFault,
      __BaseException
    >
  );
}
export interface CreateReplicationGroupMessage {
  ReplicationGroupId: string | undefined;
  ReplicationGroupDescription: string | undefined;
  GlobalReplicationGroupId?: string | undefined;
  PrimaryClusterId?: string | undefined;
  AutomaticFailoverEnabled?: boolean | undefined;
  MultiAZEnabled?: boolean | undefined;
  NumCacheClusters?: number | undefined;
  PreferredCacheClusterAZs?: string[] | undefined;
  NumNodeGroups?: number | undefined;
  ReplicasPerNodeGroup?: number | undefined;
  NodeGroupConfiguration?: NodeGroupConfiguration[] | undefined;
  CacheNodeType?: string | undefined;
  Engine?: string | undefined;
  EngineVersion?: string | undefined;
  CacheParameterGroupName?: string | undefined;
  CacheSubnetGroupName?: string | undefined;
  CacheSecurityGroupNames?: string[] | undefined;
  SecurityGroupIds?: string[] | undefined;
  Tags?: Tag[] | undefined;
  SnapshotArns?: string[] | undefined;
  SnapshotName?: string | undefined;
  PreferredMaintenanceWindow?: string | undefined;
  Port?: number | undefined;
  NotificationTopicArn?: string | undefined;
  AutoMinorVersionUpgrade?: boolean | undefined;
  SnapshotRetentionLimit?: number | undefined;
  SnapshotWindow?: string | undefined;
  AuthToken?: string | undefined;
  TransitEncryptionEnabled?: boolean | undefined;
  AtRestEncryptionEnabled?: boolean | undefined;
  KmsKeyId?: string | undefined;
  UserGroupIds?: string[] | undefined;
  LogDeliveryConfigurations?: LogDeliveryConfigurationRequest[] | undefined;
  DataTieringEnabled?: boolean | undefined;
  NetworkType?: NetworkType | undefined;
  IpDiscovery?: IpDiscovery | undefined;
  TransitEncryptionMode?: TransitEncryptionMode | undefined;
  ClusterMode?: ClusterMode | undefined;
  ServerlessCacheSnapshotName?: string | undefined;
}
export interface CreateReplicationGroupResult {
  ReplicationGroup?: ReplicationGroup | undefined;
}
export declare class GlobalReplicationGroupNotFoundFault extends __BaseException {
  readonly name: "GlobalReplicationGroupNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      GlobalReplicationGroupNotFoundFault,
      __BaseException
    >
  );
}
export declare class InvalidCacheClusterStateFault extends __BaseException {
  readonly name: "InvalidCacheClusterStateFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidCacheClusterStateFault, __BaseException>
  );
}
export declare class InvalidGlobalReplicationGroupStateFault extends __BaseException {
  readonly name: "InvalidGlobalReplicationGroupStateFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      InvalidGlobalReplicationGroupStateFault,
      __BaseException
    >
  );
}
export declare class InvalidUserGroupStateFault extends __BaseException {
  readonly name: "InvalidUserGroupStateFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidUserGroupStateFault, __BaseException>
  );
}
export declare class NodeGroupsPerReplicationGroupQuotaExceededFault extends __BaseException {
  readonly name: "NodeGroupsPerReplicationGroupQuotaExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      NodeGroupsPerReplicationGroupQuotaExceededFault,
      __BaseException
    >
  );
}
export declare class ReplicationGroupAlreadyExistsFault extends __BaseException {
  readonly name: "ReplicationGroupAlreadyExistsFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      ReplicationGroupAlreadyExistsFault,
      __BaseException
    >
  );
}
export declare const DataStorageUnit: {
  readonly GB: "GB";
};
export type DataStorageUnit =
  (typeof DataStorageUnit)[keyof typeof DataStorageUnit];
export interface DataStorage {
  Maximum?: number | undefined;
  Minimum?: number | undefined;
  Unit: DataStorageUnit | undefined;
}
export interface ECPUPerSecond {
  Maximum?: number | undefined;
  Minimum?: number | undefined;
}
export interface CacheUsageLimits {
  DataStorage?: DataStorage | undefined;
  ECPUPerSecond?: ECPUPerSecond | undefined;
}
export interface CreateServerlessCacheRequest {
  ServerlessCacheName: string | undefined;
  Description?: string | undefined;
  Engine: string | undefined;
  MajorEngineVersion?: string | undefined;
  CacheUsageLimits?: CacheUsageLimits | undefined;
  KmsKeyId?: string | undefined;
  SecurityGroupIds?: string[] | undefined;
  SnapshotArnsToRestore?: string[] | undefined;
  Tags?: Tag[] | undefined;
  UserGroupId?: string | undefined;
  SubnetIds?: string[] | undefined;
  SnapshotRetentionLimit?: number | undefined;
  DailySnapshotTime?: string | undefined;
}
export interface ServerlessCache {
  ServerlessCacheName?: string | undefined;
  Description?: string | undefined;
  CreateTime?: Date | undefined;
  Status?: string | undefined;
  Engine?: string | undefined;
  MajorEngineVersion?: string | undefined;
  FullEngineVersion?: string | undefined;
  CacheUsageLimits?: CacheUsageLimits | undefined;
  KmsKeyId?: string | undefined;
  SecurityGroupIds?: string[] | undefined;
  Endpoint?: Endpoint | undefined;
  ReaderEndpoint?: Endpoint | undefined;
  ARN?: string | undefined;
  UserGroupId?: string | undefined;
  SubnetIds?: string[] | undefined;
  SnapshotRetentionLimit?: number | undefined;
  DailySnapshotTime?: string | undefined;
}
export interface CreateServerlessCacheResponse {
  ServerlessCache?: ServerlessCache | undefined;
}
export declare class InvalidCredentialsException extends __BaseException {
  readonly name: "InvalidCredentialsException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidCredentialsException, __BaseException>
  );
}
export declare class ServerlessCacheAlreadyExistsFault extends __BaseException {
  readonly name: "ServerlessCacheAlreadyExistsFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      ServerlessCacheAlreadyExistsFault,
      __BaseException
    >
  );
}
export declare class ServerlessCacheQuotaForCustomerExceededFault extends __BaseException {
  readonly name: "ServerlessCacheQuotaForCustomerExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      ServerlessCacheQuotaForCustomerExceededFault,
      __BaseException
    >
  );
}
export interface CreateServerlessCacheSnapshotRequest {
  ServerlessCacheSnapshotName: string | undefined;
  ServerlessCacheName: string | undefined;
  KmsKeyId?: string | undefined;
  Tags?: Tag[] | undefined;
}
export interface CreateServerlessCacheSnapshotResponse {
  ServerlessCacheSnapshot?: ServerlessCacheSnapshot | undefined;
}
export interface CreateSnapshotMessage {
  ReplicationGroupId?: string | undefined;
  CacheClusterId?: string | undefined;
  SnapshotName: string | undefined;
  KmsKeyId?: string | undefined;
  Tags?: Tag[] | undefined;
}
export interface CreateSnapshotResult {
  Snapshot?: Snapshot | undefined;
}
export declare class SnapshotFeatureNotSupportedFault extends __BaseException {
  readonly name: "SnapshotFeatureNotSupportedFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      SnapshotFeatureNotSupportedFault,
      __BaseException
    >
  );
}
export declare const InputAuthenticationType: {
  readonly IAM: "iam";
  readonly NO_PASSWORD: "no-password-required";
  readonly PASSWORD: "password";
};
export type InputAuthenticationType =
  (typeof InputAuthenticationType)[keyof typeof InputAuthenticationType];
export interface AuthenticationMode {
  Type?: InputAuthenticationType | undefined;
  Passwords?: string[] | undefined;
}
export interface CreateUserMessage {
  UserId: string | undefined;
  UserName: string | undefined;
  Engine: string | undefined;
  Passwords?: string[] | undefined;
  AccessString: string | undefined;
  NoPasswordRequired?: boolean | undefined;
  Tags?: Tag[] | undefined;
  AuthenticationMode?: AuthenticationMode | undefined;
}
export declare class DuplicateUserNameFault extends __BaseException {
  readonly name: "DuplicateUserNameFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<DuplicateUserNameFault, __BaseException>
  );
}
export declare const AuthenticationType: {
  readonly IAM: "iam";
  readonly NO_PASSWORD: "no-password";
  readonly PASSWORD: "password";
};
export type AuthenticationType =
  (typeof AuthenticationType)[keyof typeof AuthenticationType];
export interface Authentication {
  Type?: AuthenticationType | undefined;
  PasswordCount?: number | undefined;
}
export interface User {
  UserId?: string | undefined;
  UserName?: string | undefined;
  Status?: string | undefined;
  Engine?: string | undefined;
  MinimumEngineVersion?: string | undefined;
  AccessString?: string | undefined;
  UserGroupIds?: string[] | undefined;
  Authentication?: Authentication | undefined;
  ARN?: string | undefined;
}
export declare class UserAlreadyExistsFault extends __BaseException {
  readonly name: "UserAlreadyExistsFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<UserAlreadyExistsFault, __BaseException>
  );
}
export declare class UserQuotaExceededFault extends __BaseException {
  readonly name: "UserQuotaExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<UserQuotaExceededFault, __BaseException>
  );
}
export interface CreateUserGroupMessage {
  UserGroupId: string | undefined;
  Engine: string | undefined;
  UserIds?: string[] | undefined;
  Tags?: Tag[] | undefined;
}
export declare class DefaultUserRequired extends __BaseException {
  readonly name: "DefaultUserRequired";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<DefaultUserRequired, __BaseException>
  );
}
export interface UserGroupPendingChanges {
  UserIdsToRemove?: string[] | undefined;
  UserIdsToAdd?: string[] | undefined;
}
export interface UserGroup {
  UserGroupId?: string | undefined;
  Status?: string | undefined;
  Engine?: string | undefined;
  UserIds?: string[] | undefined;
  MinimumEngineVersion?: string | undefined;
  PendingChanges?: UserGroupPendingChanges | undefined;
  ReplicationGroups?: string[] | undefined;
  ServerlessCaches?: string[] | undefined;
  ARN?: string | undefined;
}
export declare class UserGroupAlreadyExistsFault extends __BaseException {
  readonly name: "UserGroupAlreadyExistsFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<UserGroupAlreadyExistsFault, __BaseException>
  );
}
export declare class UserGroupQuotaExceededFault extends __BaseException {
  readonly name: "UserGroupQuotaExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<UserGroupQuotaExceededFault, __BaseException>
  );
}
export interface DecreaseNodeGroupsInGlobalReplicationGroupMessage {
  GlobalReplicationGroupId: string | undefined;
  NodeGroupCount: number | undefined;
  GlobalNodeGroupsToRemove?: string[] | undefined;
  GlobalNodeGroupsToRetain?: string[] | undefined;
  ApplyImmediately: boolean | undefined;
}
export interface DecreaseNodeGroupsInGlobalReplicationGroupResult {
  GlobalReplicationGroup?: GlobalReplicationGroup | undefined;
}
export interface ConfigureShard {
  NodeGroupId: string | undefined;
  NewReplicaCount: number | undefined;
  PreferredAvailabilityZones?: string[] | undefined;
  PreferredOutpostArns?: string[] | undefined;
}
export interface DecreaseReplicaCountMessage {
  ReplicationGroupId: string | undefined;
  NewReplicaCount?: number | undefined;
  ReplicaConfiguration?: ConfigureShard[] | undefined;
  ReplicasToRemove?: string[] | undefined;
  ApplyImmediately: boolean | undefined;
}
export interface DecreaseReplicaCountResult {
  ReplicationGroup?: ReplicationGroup | undefined;
}
export declare class NoOperationFault extends __BaseException {
  readonly name: "NoOperationFault";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<NoOperationFault, __BaseException>);
}
export interface DeleteCacheClusterMessage {
  CacheClusterId: string | undefined;
  FinalSnapshotIdentifier?: string | undefined;
}
export interface DeleteCacheClusterResult {
  CacheCluster?: CacheCluster | undefined;
}
export interface DeleteCacheParameterGroupMessage {
  CacheParameterGroupName: string | undefined;
}
export interface DeleteCacheSecurityGroupMessage {
  CacheSecurityGroupName: string | undefined;
}
export declare class CacheSubnetGroupInUse extends __BaseException {
  readonly name: "CacheSubnetGroupInUse";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<CacheSubnetGroupInUse, __BaseException>
  );
}
export interface DeleteCacheSubnetGroupMessage {
  CacheSubnetGroupName: string | undefined;
}
export interface DeleteGlobalReplicationGroupMessage {
  GlobalReplicationGroupId: string | undefined;
  RetainPrimaryReplicationGroup: boolean | undefined;
}
export interface DeleteGlobalReplicationGroupResult {
  GlobalReplicationGroup?: GlobalReplicationGroup | undefined;
}
export interface DeleteReplicationGroupMessage {
  ReplicationGroupId: string | undefined;
  RetainPrimaryCluster?: boolean | undefined;
  FinalSnapshotIdentifier?: string | undefined;
}
export interface DeleteReplicationGroupResult {
  ReplicationGroup?: ReplicationGroup | undefined;
}
export interface DeleteServerlessCacheRequest {
  ServerlessCacheName: string | undefined;
  FinalSnapshotName?: string | undefined;
}
export interface DeleteServerlessCacheResponse {
  ServerlessCache?: ServerlessCache | undefined;
}
export interface DeleteServerlessCacheSnapshotRequest {
  ServerlessCacheSnapshotName: string | undefined;
}
export interface DeleteServerlessCacheSnapshotResponse {
  ServerlessCacheSnapshot?: ServerlessCacheSnapshot | undefined;
}
export interface DeleteSnapshotMessage {
  SnapshotName: string | undefined;
}
export interface DeleteSnapshotResult {
  Snapshot?: Snapshot | undefined;
}
export declare class DefaultUserAssociatedToUserGroupFault extends __BaseException {
  readonly name: "DefaultUserAssociatedToUserGroupFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      DefaultUserAssociatedToUserGroupFault,
      __BaseException
    >
  );
}
export interface DeleteUserMessage {
  UserId: string | undefined;
}
export declare class InvalidUserStateFault extends __BaseException {
  readonly name: "InvalidUserStateFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidUserStateFault, __BaseException>
  );
}
export interface DeleteUserGroupMessage {
  UserGroupId: string | undefined;
}
export interface CacheClusterMessage {
  Marker?: string | undefined;
  CacheClusters?: CacheCluster[] | undefined;
}
export interface DescribeCacheClustersMessage {
  CacheClusterId?: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
  ShowCacheNodeInfo?: boolean | undefined;
  ShowCacheClustersNotInReplicationGroups?: boolean | undefined;
}
export interface CacheEngineVersion {
  Engine?: string | undefined;
  EngineVersion?: string | undefined;
  CacheParameterGroupFamily?: string | undefined;
  CacheEngineDescription?: string | undefined;
  CacheEngineVersionDescription?: string | undefined;
}
export interface CacheEngineVersionMessage {
  Marker?: string | undefined;
  CacheEngineVersions?: CacheEngineVersion[] | undefined;
}
export interface DescribeCacheEngineVersionsMessage {
  Engine?: string | undefined;
  EngineVersion?: string | undefined;
  CacheParameterGroupFamily?: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
  DefaultOnly?: boolean | undefined;
}
export interface CacheParameterGroupsMessage {
  Marker?: string | undefined;
  CacheParameterGroups?: CacheParameterGroup[] | undefined;
}
export interface DescribeCacheParameterGroupsMessage {
  CacheParameterGroupName?: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface CacheNodeTypeSpecificValue {
  CacheNodeType?: string | undefined;
  Value?: string | undefined;
}
export declare const ChangeType: {
  readonly immediate: "immediate";
  readonly requires_reboot: "requires-reboot";
};
export type ChangeType = (typeof ChangeType)[keyof typeof ChangeType];
export interface CacheNodeTypeSpecificParameter {
  ParameterName?: string | undefined;
  Description?: string | undefined;
  Source?: string | undefined;
  DataType?: string | undefined;
  AllowedValues?: string | undefined;
  IsModifiable?: boolean | undefined;
  MinimumEngineVersion?: string | undefined;
  CacheNodeTypeSpecificValues?: CacheNodeTypeSpecificValue[] | undefined;
  ChangeType?: ChangeType | undefined;
}
export interface Parameter {
  ParameterName?: string | undefined;
  ParameterValue?: string | undefined;
  Description?: string | undefined;
  Source?: string | undefined;
  DataType?: string | undefined;
  AllowedValues?: string | undefined;
  IsModifiable?: boolean | undefined;
  MinimumEngineVersion?: string | undefined;
  ChangeType?: ChangeType | undefined;
}
export interface CacheParameterGroupDetails {
  Marker?: string | undefined;
  Parameters?: Parameter[] | undefined;
  CacheNodeTypeSpecificParameters?:
    | CacheNodeTypeSpecificParameter[]
    | undefined;
}
export interface DescribeCacheParametersMessage {
  CacheParameterGroupName: string | undefined;
  Source?: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface CacheSecurityGroupMessage {
  Marker?: string | undefined;
  CacheSecurityGroups?: CacheSecurityGroup[] | undefined;
}
export interface DescribeCacheSecurityGroupsMessage {
  CacheSecurityGroupName?: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface CacheSubnetGroupMessage {
  Marker?: string | undefined;
  CacheSubnetGroups?: CacheSubnetGroup[] | undefined;
}
export interface DescribeCacheSubnetGroupsMessage {
  CacheSubnetGroupName?: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeEngineDefaultParametersMessage {
  CacheParameterGroupFamily: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface EngineDefaults {
  CacheParameterGroupFamily?: string | undefined;
  Marker?: string | undefined;
  Parameters?: Parameter[] | undefined;
  CacheNodeTypeSpecificParameters?:
    | CacheNodeTypeSpecificParameter[]
    | undefined;
}
export interface DescribeEngineDefaultParametersResult {
  EngineDefaults?: EngineDefaults | undefined;
}
export declare const SourceType: {
  readonly cache_cluster: "cache-cluster";
  readonly cache_parameter_group: "cache-parameter-group";
  readonly cache_security_group: "cache-security-group";
  readonly cache_subnet_group: "cache-subnet-group";
  readonly replication_group: "replication-group";
  readonly serverless_cache: "serverless-cache";
  readonly serverless_cache_snapshot: "serverless-cache-snapshot";
  readonly user: "user";
  readonly user_group: "user-group";
};
export type SourceType = (typeof SourceType)[keyof typeof SourceType];
export interface DescribeEventsMessage {
  SourceIdentifier?: string | undefined;
  SourceType?: SourceType | undefined;
  StartTime?: Date | undefined;
  EndTime?: Date | undefined;
  Duration?: number | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface Event {
  SourceIdentifier?: string | undefined;
  SourceType?: SourceType | undefined;
  Message?: string | undefined;
  Date?: Date | undefined;
}
export interface EventsMessage {
  Marker?: string | undefined;
  Events?: Event[] | undefined;
}
export interface DescribeGlobalReplicationGroupsMessage {
  GlobalReplicationGroupId?: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
  ShowMemberInfo?: boolean | undefined;
}
export interface DescribeGlobalReplicationGroupsResult {
  Marker?: string | undefined;
  GlobalReplicationGroups?: GlobalReplicationGroup[] | undefined;
}
export interface DescribeReplicationGroupsMessage {
  ReplicationGroupId?: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface ReplicationGroupMessage {
  Marker?: string | undefined;
  ReplicationGroups?: ReplicationGroup[] | undefined;
}
export interface DescribeReservedCacheNodesMessage {
  ReservedCacheNodeId?: string | undefined;
  ReservedCacheNodesOfferingId?: string | undefined;
  CacheNodeType?: string | undefined;
  Duration?: string | undefined;
  ProductDescription?: string | undefined;
  OfferingType?: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface RecurringCharge {
  RecurringChargeAmount?: number | undefined;
  RecurringChargeFrequency?: string | undefined;
}
export interface ReservedCacheNode {
  ReservedCacheNodeId?: string | undefined;
  ReservedCacheNodesOfferingId?: string | undefined;
  CacheNodeType?: string | undefined;
  StartTime?: Date | undefined;
  Duration?: number | undefined;
  FixedPrice?: number | undefined;
  UsagePrice?: number | undefined;
  CacheNodeCount?: number | undefined;
  ProductDescription?: string | undefined;
  OfferingType?: string | undefined;
  State?: string | undefined;
  RecurringCharges?: RecurringCharge[] | undefined;
  ReservationARN?: string | undefined;
}
export interface ReservedCacheNodeMessage {
  Marker?: string | undefined;
  ReservedCacheNodes?: ReservedCacheNode[] | undefined;
}
export interface DescribeReservedCacheNodesOfferingsMessage {
  ReservedCacheNodesOfferingId?: string | undefined;
  CacheNodeType?: string | undefined;
  Duration?: string | undefined;
  ProductDescription?: string | undefined;
  OfferingType?: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface ReservedCacheNodesOffering {
  ReservedCacheNodesOfferingId?: string | undefined;
  CacheNodeType?: string | undefined;
  Duration?: number | undefined;
  FixedPrice?: number | undefined;
  UsagePrice?: number | undefined;
  ProductDescription?: string | undefined;
  OfferingType?: string | undefined;
  RecurringCharges?: RecurringCharge[] | undefined;
}
export interface ReservedCacheNodesOfferingMessage {
  Marker?: string | undefined;
  ReservedCacheNodesOfferings?: ReservedCacheNodesOffering[] | undefined;
}
export declare class ReservedCacheNodesOfferingNotFoundFault extends __BaseException {
  readonly name: "ReservedCacheNodesOfferingNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      ReservedCacheNodesOfferingNotFoundFault,
      __BaseException
    >
  );
}
export interface DescribeServerlessCachesRequest {
  ServerlessCacheName?: string | undefined;
  MaxResults?: number | undefined;
  NextToken?: string | undefined;
}
export interface DescribeServerlessCachesResponse {
  NextToken?: string | undefined;
  ServerlessCaches?: ServerlessCache[] | undefined;
}
export interface DescribeServerlessCacheSnapshotsRequest {
  ServerlessCacheName?: string | undefined;
  ServerlessCacheSnapshotName?: string | undefined;
  SnapshotType?: string | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
}
export interface DescribeServerlessCacheSnapshotsResponse {
  NextToken?: string | undefined;
  ServerlessCacheSnapshots?: ServerlessCacheSnapshot[] | undefined;
}
export declare const ServiceUpdateStatus: {
  readonly AVAILABLE: "available";
  readonly CANCELLED: "cancelled";
  readonly EXPIRED: "expired";
};
export type ServiceUpdateStatus =
  (typeof ServiceUpdateStatus)[keyof typeof ServiceUpdateStatus];
export interface DescribeServiceUpdatesMessage {
  ServiceUpdateName?: string | undefined;
  ServiceUpdateStatus?: ServiceUpdateStatus[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export declare const ServiceUpdateSeverity: {
  readonly CRITICAL: "critical";
  readonly IMPORTANT: "important";
  readonly LOW: "low";
  readonly MEDIUM: "medium";
};
export type ServiceUpdateSeverity =
  (typeof ServiceUpdateSeverity)[keyof typeof ServiceUpdateSeverity];
export declare const ServiceUpdateType: {
  readonly SECURITY_UPDATE: "security-update";
};
export type ServiceUpdateType =
  (typeof ServiceUpdateType)[keyof typeof ServiceUpdateType];
export interface ServiceUpdate {
  ServiceUpdateName?: string | undefined;
  ServiceUpdateReleaseDate?: Date | undefined;
  ServiceUpdateEndDate?: Date | undefined;
  ServiceUpdateSeverity?: ServiceUpdateSeverity | undefined;
  ServiceUpdateRecommendedApplyByDate?: Date | undefined;
  ServiceUpdateStatus?: ServiceUpdateStatus | undefined;
  ServiceUpdateDescription?: string | undefined;
  ServiceUpdateType?: ServiceUpdateType | undefined;
  Engine?: string | undefined;
  EngineVersion?: string | undefined;
  AutoUpdateAfterRecommendedApplyByDate?: boolean | undefined;
  EstimatedUpdateTime?: string | undefined;
}
export interface ServiceUpdatesMessage {
  Marker?: string | undefined;
  ServiceUpdates?: ServiceUpdate[] | undefined;
}
export interface DescribeSnapshotsListMessage {
  Marker?: string | undefined;
  Snapshots?: Snapshot[] | undefined;
}
export interface DescribeSnapshotsMessage {
  ReplicationGroupId?: string | undefined;
  CacheClusterId?: string | undefined;
  SnapshotName?: string | undefined;
  SnapshotSource?: string | undefined;
  Marker?: string | undefined;
  MaxRecords?: number | undefined;
  ShowNodeGroupConfig?: boolean | undefined;
}
export interface TimeRangeFilter {
  StartTime?: Date | undefined;
  EndTime?: Date | undefined;
}
export interface DescribeUpdateActionsMessage {
  ServiceUpdateName?: string | undefined;
  ReplicationGroupIds?: string[] | undefined;
  CacheClusterIds?: string[] | undefined;
  Engine?: string | undefined;
  ServiceUpdateStatus?: ServiceUpdateStatus[] | undefined;
  ServiceUpdateTimeRange?: TimeRangeFilter | undefined;
  UpdateActionStatus?: UpdateActionStatus[] | undefined;
  ShowNodeLevelUpdateStatus?: boolean | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export declare const NodeUpdateInitiatedBy: {
  readonly CUSTOMER: "customer";
  readonly SYSTEM: "system";
};
export type NodeUpdateInitiatedBy =
  (typeof NodeUpdateInitiatedBy)[keyof typeof NodeUpdateInitiatedBy];
export declare const NodeUpdateStatus: {
  readonly COMPLETE: "complete";
  readonly IN_PROGRESS: "in-progress";
  readonly NOT_APPLIED: "not-applied";
  readonly STOPPED: "stopped";
  readonly STOPPING: "stopping";
  readonly WAITING_TO_START: "waiting-to-start";
};
export type NodeUpdateStatus =
  (typeof NodeUpdateStatus)[keyof typeof NodeUpdateStatus];
export interface CacheNodeUpdateStatus {
  CacheNodeId?: string | undefined;
  NodeUpdateStatus?: NodeUpdateStatus | undefined;
  NodeDeletionDate?: Date | undefined;
  NodeUpdateStartDate?: Date | undefined;
  NodeUpdateEndDate?: Date | undefined;
  NodeUpdateInitiatedBy?: NodeUpdateInitiatedBy | undefined;
  NodeUpdateInitiatedDate?: Date | undefined;
  NodeUpdateStatusModifiedDate?: Date | undefined;
}
export interface NodeGroupMemberUpdateStatus {
  CacheClusterId?: string | undefined;
  CacheNodeId?: string | undefined;
  NodeUpdateStatus?: NodeUpdateStatus | undefined;
  NodeDeletionDate?: Date | undefined;
  NodeUpdateStartDate?: Date | undefined;
  NodeUpdateEndDate?: Date | undefined;
  NodeUpdateInitiatedBy?: NodeUpdateInitiatedBy | undefined;
  NodeUpdateInitiatedDate?: Date | undefined;
  NodeUpdateStatusModifiedDate?: Date | undefined;
}
export interface NodeGroupUpdateStatus {
  NodeGroupId?: string | undefined;
  NodeGroupMemberUpdateStatus?: NodeGroupMemberUpdateStatus[] | undefined;
}
export declare const SlaMet: {
  readonly NA: "n/a";
  readonly NO: "no";
  readonly YES: "yes";
};
export type SlaMet = (typeof SlaMet)[keyof typeof SlaMet];
export interface UpdateAction {
  ReplicationGroupId?: string | undefined;
  CacheClusterId?: string | undefined;
  ServiceUpdateName?: string | undefined;
  ServiceUpdateReleaseDate?: Date | undefined;
  ServiceUpdateSeverity?: ServiceUpdateSeverity | undefined;
  ServiceUpdateStatus?: ServiceUpdateStatus | undefined;
  ServiceUpdateRecommendedApplyByDate?: Date | undefined;
  ServiceUpdateType?: ServiceUpdateType | undefined;
  UpdateActionAvailableDate?: Date | undefined;
  UpdateActionStatus?: UpdateActionStatus | undefined;
  NodesUpdated?: string | undefined;
  UpdateActionStatusModifiedDate?: Date | undefined;
  SlaMet?: SlaMet | undefined;
  NodeGroupUpdateStatus?: NodeGroupUpdateStatus[] | undefined;
  CacheNodeUpdateStatus?: CacheNodeUpdateStatus[] | undefined;
  EstimatedUpdateTime?: string | undefined;
  Engine?: string | undefined;
}
export interface UpdateActionsMessage {
  Marker?: string | undefined;
  UpdateActions?: UpdateAction[] | undefined;
}
export interface DescribeUserGroupsMessage {
  UserGroupId?: string | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeUserGroupsResult {
  UserGroups?: UserGroup[] | undefined;
  Marker?: string | undefined;
}
export interface Filter {
  Name: string | undefined;
  Values: string[] | undefined;
}
export interface DescribeUsersMessage {
  Engine?: string | undefined;
  UserId?: string | undefined;
  Filters?: Filter[] | undefined;
  MaxRecords?: number | undefined;
  Marker?: string | undefined;
}
export interface DescribeUsersResult {
  Users?: User[] | undefined;
  Marker?: string | undefined;
}
export interface DisassociateGlobalReplicationGroupMessage {
  GlobalReplicationGroupId: string | undefined;
  ReplicationGroupId: string | undefined;
  ReplicationGroupRegion: string | undefined;
}
export interface DisassociateGlobalReplicationGroupResult {
  GlobalReplicationGroup?: GlobalReplicationGroup | undefined;
}
export interface ExportServerlessCacheSnapshotRequest {
  ServerlessCacheSnapshotName: string | undefined;
  S3BucketName: string | undefined;
}
export interface ExportServerlessCacheSnapshotResponse {
  ServerlessCacheSnapshot?: ServerlessCacheSnapshot | undefined;
}
export interface FailoverGlobalReplicationGroupMessage {
  GlobalReplicationGroupId: string | undefined;
  PrimaryRegion: string | undefined;
  PrimaryReplicationGroupId: string | undefined;
}
export interface FailoverGlobalReplicationGroupResult {
  GlobalReplicationGroup?: GlobalReplicationGroup | undefined;
}
export interface ReshardingConfiguration {
  NodeGroupId?: string | undefined;
  PreferredAvailabilityZones?: string[] | undefined;
}
export interface RegionalConfiguration {
  ReplicationGroupId: string | undefined;
  ReplicationGroupRegion: string | undefined;
  ReshardingConfiguration: ReshardingConfiguration[] | undefined;
}
export interface IncreaseNodeGroupsInGlobalReplicationGroupMessage {
  GlobalReplicationGroupId: string | undefined;
  NodeGroupCount: number | undefined;
  RegionalConfigurations?: RegionalConfiguration[] | undefined;
  ApplyImmediately: boolean | undefined;
}
export interface IncreaseNodeGroupsInGlobalReplicationGroupResult {
  GlobalReplicationGroup?: GlobalReplicationGroup | undefined;
}
export interface IncreaseReplicaCountMessage {
  ReplicationGroupId: string | undefined;
  NewReplicaCount?: number | undefined;
  ReplicaConfiguration?: ConfigureShard[] | undefined;
  ApplyImmediately: boolean | undefined;
}
export interface IncreaseReplicaCountResult {
  ReplicationGroup?: ReplicationGroup | undefined;
}
export declare class InvalidKMSKeyFault extends __BaseException {
  readonly name: "InvalidKMSKeyFault";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<InvalidKMSKeyFault, __BaseException>);
}
export interface ListAllowedNodeTypeModificationsMessage {
  CacheClusterId?: string | undefined;
  ReplicationGroupId?: string | undefined;
}
export interface ListTagsForResourceMessage {
  ResourceName: string | undefined;
}
export declare const AuthTokenUpdateStrategyType: {
  readonly DELETE: "DELETE";
  readonly ROTATE: "ROTATE";
  readonly SET: "SET";
};
export type AuthTokenUpdateStrategyType =
  (typeof AuthTokenUpdateStrategyType)[keyof typeof AuthTokenUpdateStrategyType];
export interface ModifyCacheClusterMessage {
  CacheClusterId: string | undefined;
  NumCacheNodes?: number | undefined;
  CacheNodeIdsToRemove?: string[] | undefined;
  AZMode?: AZMode | undefined;
  NewAvailabilityZones?: string[] | undefined;
  CacheSecurityGroupNames?: string[] | undefined;
  SecurityGroupIds?: string[] | undefined;
  PreferredMaintenanceWindow?: string | undefined;
  NotificationTopicArn?: string | undefined;
  CacheParameterGroupName?: string | undefined;
  NotificationTopicStatus?: string | undefined;
  ApplyImmediately?: boolean | undefined;
  Engine?: string | undefined;
  EngineVersion?: string | undefined;
  AutoMinorVersionUpgrade?: boolean | undefined;
  SnapshotRetentionLimit?: number | undefined;
  SnapshotWindow?: string | undefined;
  CacheNodeType?: string | undefined;
  AuthToken?: string | undefined;
  AuthTokenUpdateStrategy?: AuthTokenUpdateStrategyType | undefined;
  LogDeliveryConfigurations?: LogDeliveryConfigurationRequest[] | undefined;
  IpDiscovery?: IpDiscovery | undefined;
  ScaleConfig?: ScaleConfig | undefined;
}
export interface ModifyCacheClusterResult {
  CacheCluster?: CacheCluster | undefined;
}
export interface CacheParameterGroupNameMessage {
  CacheParameterGroupName?: string | undefined;
}
export interface ParameterNameValue {
  ParameterName?: string | undefined;
  ParameterValue?: string | undefined;
}
export interface ModifyCacheParameterGroupMessage {
  CacheParameterGroupName: string | undefined;
  ParameterNameValues: ParameterNameValue[] | undefined;
}
export interface ModifyCacheSubnetGroupMessage {
  CacheSubnetGroupName: string | undefined;
  CacheSubnetGroupDescription?: string | undefined;
  SubnetIds?: string[] | undefined;
}
export interface ModifyCacheSubnetGroupResult {
  CacheSubnetGroup?: CacheSubnetGroup | undefined;
}
export declare class SubnetInUse extends __BaseException {
  readonly name: "SubnetInUse";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<SubnetInUse, __BaseException>);
}
export interface ModifyGlobalReplicationGroupMessage {
  GlobalReplicationGroupId: string | undefined;
  ApplyImmediately: boolean | undefined;
  CacheNodeType?: string | undefined;
  Engine?: string | undefined;
  EngineVersion?: string | undefined;
  CacheParameterGroupName?: string | undefined;
  GlobalReplicationGroupDescription?: string | undefined;
  AutomaticFailoverEnabled?: boolean | undefined;
}
export interface ModifyGlobalReplicationGroupResult {
  GlobalReplicationGroup?: GlobalReplicationGroup | undefined;
}
export interface ModifyReplicationGroupMessage {
  ReplicationGroupId: string | undefined;
  ReplicationGroupDescription?: string | undefined;
  PrimaryClusterId?: string | undefined;
  SnapshottingClusterId?: string | undefined;
  AutomaticFailoverEnabled?: boolean | undefined;
  MultiAZEnabled?: boolean | undefined;
  NodeGroupId?: string | undefined;
  CacheSecurityGroupNames?: string[] | undefined;
  SecurityGroupIds?: string[] | undefined;
  PreferredMaintenanceWindow?: string | undefined;
  NotificationTopicArn?: string | undefined;
  CacheParameterGroupName?: string | undefined;
  NotificationTopicStatus?: string | undefined;
  ApplyImmediately?: boolean | undefined;
  Engine?: string | undefined;
  EngineVersion?: string | undefined;
  AutoMinorVersionUpgrade?: boolean | undefined;
  SnapshotRetentionLimit?: number | undefined;
  SnapshotWindow?: string | undefined;
  CacheNodeType?: string | undefined;
  AuthToken?: string | undefined;
  AuthTokenUpdateStrategy?: AuthTokenUpdateStrategyType | undefined;
  UserGroupIdsToAdd?: string[] | undefined;
  UserGroupIdsToRemove?: string[] | undefined;
  RemoveUserGroups?: boolean | undefined;
  LogDeliveryConfigurations?: LogDeliveryConfigurationRequest[] | undefined;
  IpDiscovery?: IpDiscovery | undefined;
  TransitEncryptionEnabled?: boolean | undefined;
  TransitEncryptionMode?: TransitEncryptionMode | undefined;
  ClusterMode?: ClusterMode | undefined;
}
export interface ModifyReplicationGroupResult {
  ReplicationGroup?: ReplicationGroup | undefined;
}
export interface ModifyReplicationGroupShardConfigurationMessage {
  ReplicationGroupId: string | undefined;
  NodeGroupCount: number | undefined;
  ApplyImmediately: boolean | undefined;
  ReshardingConfiguration?: ReshardingConfiguration[] | undefined;
  NodeGroupsToRemove?: string[] | undefined;
  NodeGroupsToRetain?: string[] | undefined;
}
export interface ModifyReplicationGroupShardConfigurationResult {
  ReplicationGroup?: ReplicationGroup | undefined;
}
export interface ModifyServerlessCacheRequest {
  ServerlessCacheName: string | undefined;
  Description?: string | undefined;
  CacheUsageLimits?: CacheUsageLimits | undefined;
  RemoveUserGroup?: boolean | undefined;
  UserGroupId?: string | undefined;
  SecurityGroupIds?: string[] | undefined;
  SnapshotRetentionLimit?: number | undefined;
  DailySnapshotTime?: string | undefined;
  Engine?: string | undefined;
  MajorEngineVersion?: string | undefined;
}
export interface ModifyServerlessCacheResponse {
  ServerlessCache?: ServerlessCache | undefined;
}
export interface ModifyUserMessage {
  UserId: string | undefined;
  AccessString?: string | undefined;
  AppendAccessString?: string | undefined;
  Passwords?: string[] | undefined;
  NoPasswordRequired?: boolean | undefined;
  AuthenticationMode?: AuthenticationMode | undefined;
  Engine?: string | undefined;
}
export interface ModifyUserGroupMessage {
  UserGroupId: string | undefined;
  UserIdsToAdd?: string[] | undefined;
  UserIdsToRemove?: string[] | undefined;
  Engine?: string | undefined;
}
export interface PurchaseReservedCacheNodesOfferingMessage {
  ReservedCacheNodesOfferingId: string | undefined;
  ReservedCacheNodeId?: string | undefined;
  CacheNodeCount?: number | undefined;
  Tags?: Tag[] | undefined;
}
export interface PurchaseReservedCacheNodesOfferingResult {
  ReservedCacheNode?: ReservedCacheNode | undefined;
}
export declare class ReservedCacheNodeAlreadyExistsFault extends __BaseException {
  readonly name: "ReservedCacheNodeAlreadyExistsFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      ReservedCacheNodeAlreadyExistsFault,
      __BaseException
    >
  );
}
export declare class ReservedCacheNodeQuotaExceededFault extends __BaseException {
  readonly name: "ReservedCacheNodeQuotaExceededFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      ReservedCacheNodeQuotaExceededFault,
      __BaseException
    >
  );
}
export interface RebalanceSlotsInGlobalReplicationGroupMessage {
  GlobalReplicationGroupId: string | undefined;
  ApplyImmediately: boolean | undefined;
}
export interface RebalanceSlotsInGlobalReplicationGroupResult {
  GlobalReplicationGroup?: GlobalReplicationGroup | undefined;
}
export interface RebootCacheClusterMessage {
  CacheClusterId: string | undefined;
  CacheNodeIdsToReboot: string[] | undefined;
}
export interface RebootCacheClusterResult {
  CacheCluster?: CacheCluster | undefined;
}
export interface RemoveTagsFromResourceMessage {
  ResourceName: string | undefined;
  TagKeys: string[] | undefined;
}
export declare class TagNotFoundFault extends __BaseException {
  readonly name: "TagNotFoundFault";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<TagNotFoundFault, __BaseException>);
}
export interface ResetCacheParameterGroupMessage {
  CacheParameterGroupName: string | undefined;
  ResetAllParameters?: boolean | undefined;
  ParameterNameValues?: ParameterNameValue[] | undefined;
}
export declare class AuthorizationNotFoundFault extends __BaseException {
  readonly name: "AuthorizationNotFoundFault";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<AuthorizationNotFoundFault, __BaseException>
  );
}
export interface RevokeCacheSecurityGroupIngressMessage {
  CacheSecurityGroupName: string | undefined;
  EC2SecurityGroupName: string | undefined;
  EC2SecurityGroupOwnerId: string | undefined;
}
